unit uNotifier;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uNotifierMAPI, ComObj, MapiX, MapiCode, MapiTags, MapiDefs, MapiGuid,
 MapiForm, MapiHook, MapiWz, MapiSpi, Imessage, Tnef, ComServ, Outlook;

type
  TForm1 = class(TForm)
    btnStartNotification: TButton;
    btnEnumerateFolders: TButton;
    memoFolderList: TMemo;
    procedure btnStartNotificationClick(Sender: TObject);
    procedure btnEnumerateFoldersClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MailNotifier: TMailNotifier;
implementation

{$R *.DFM}

procedure TForm1.btnStartNotificationClick(Sender: TObject);
var
  hr: HResult;
begin
  MailNotifier := TMailNotifier.Create;

  hr := MailNotifier.OpenDefaultMsgStore;

  if failed(hr) then
    showmessage('Failed to open default message store');

  hr := MailNotifier.RegisterForNewMail;      // fails before returning from this call

  if failed(hr) then
    showmessage('Failed register for new mail');
end;

procedure TForm1.btnEnumerateFoldersClick(Sender: TObject);
var
  ht: IMAPITable;
  hr: HResult;
  RowCount: longint;
  RowIndex: longint;
  pta: TSPropTagArray;
  prs: PSRowSet;
  rs: longint;

begin
  hr := MailNotifier.rootfolder.GetHierarchyTable(MAPI_DEFERRED_ERRORS, ht);
  if failed(hr) then
    begin
      showmessage('Could not get root hierarchy table');
      exit;
    end;

  hr := ht.GetRowCount(0, RowCount);
  if failed(hr) then
    begin
      showmessage('Get rowcount failed');
      exit;
    end
  else
    if RowCount < 1 then
      begin
        showmessage('no rows in hierarchy table');
        exit;
      end;

    // specify PR_DISPLAY_NAME for columns
    // ref: http://premium.microsoft.com/msdn/library/sdkdoc/mapisdk/tables_5c1f.htm
    pta.cValues := 1;
    pta.aulPropTag[0] := PR_DISPLAY_NAME;
    hr := ht.SetColumns(@pta, 0);

    for RowIndex := 0 to RowCount - 1 do
      begin
        hr := ht.SeekRow(BOOKMARK_BEGINNING, RowIndex, rs);
        if failed(hr) then
          begin
            ht._Release;
            exit;
          end;

        hr := ht.QueryRows(1, 0, prs);
        if failed(hr) then
          begin
            ht._Release;
            exit;
          end;

        if ((prs.cRows = 1) and (prs.aRow[0].lpProps[0].ulPropTag = PR_DISPLAY_NAME)) then
            memoFolderList.lines.add(prs.aRow[0].lpProps[0].Value.lpszA);
   end; // for

end;


end.
